
#ifndef _CCONSOLE_H
#define _CCONSOLE_H

#include <iostream>
#include <sys/time.h>
#include "speakrec.h"

using namespace std;

class CConsole {
public:
	CConsole *next;
	int fd;
	struct timeval tv;
	int currentvolume; /* 0..60 */
	int currentpeak;
	int currenttrack;
	int numoftrack;
	button_name buttonon;
	char *nameofdevice;

	CConsole(void);
	virtual ~CConsole(void){};
	virtual int flush(void) = 0;
	virtual tape_key getcommand(fd_set *read_set, tape_key lastcmd) = 0;
	virtual int fd_set_read(fd_set *read_set) = 0;
	virtual int fd_set_write(fd_set *write_set) = 0;
	virtual int redraw() = 0;
	virtual int setvolume(int newvol, int peakvol) = 0;
	virtual int showsegment(int num, unsigned char value) = 0;
	virtual int setbuttonon(button_name name) = 0;
	virtual int help(int outdev) = 0;
};

#endif
