
#ifndef _MENU_H
#define _MENU_H

#include "config.h"
#include "speakrec.h"

typedef enum {
	MN_NONE,
	MN_DELALL,
	MN_DELONE,
	MN_EXIT, /* exit menu */
	MN_QUIT /* quit program */
} menu_return;

typedef enum {
	M_ROOT,
	M_REBOOT,
	M_REBOOT_CONF,
	M_HALT,
	M_HALT_CONF,
	M_DELONE,
	M_DELONE_CONF,
	M_DELALL,
	M_DELALL_CONF,
	M_NET,
	M_NET_CONF,
	M_PLAYALL,
	M_CDREC,
	M_CDREC_AUDIO,
	M_CDREC_WAV,
	M_CDREC_OGG,
	M_CDREC_SPX,
	M_CDREC_MP3,
	M_LF30HZ,
	M_LF30HZ_CONF,
	M_RSTCNT,
	M_COPYRIGHT
} menu_id;

class CMenu {
public:
	char *currentfile;
	int current_tcount;
	char *current_text[10];

	CMenu(char *newcurrentfile);
	~CMenu(void);
	int do_action(tape_action action);
	void help(int outdev);

private:
	int idx;

	int settext(int index);
	int up(int index);
	int down(int index);
	int next(int index, int forward);
	void menulist(int outdev, int indent, menu_id root_id);
};

#endif
