/*
 * Speak Recorder
 * Copyright  2003 by Schou Industries ApS.
 */

#ifdef HAS_CONFIG_H
#include "config.h"
#endif

#include <iostream>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "speakrec.h"
#include "mouse.h"

struct {
	tape_key key;
	unsigned char but;
} bkeys[] = {
	{ key_stop, BUT_MID },
	{ key_record, BUT_LEFT },
	{ key_edit, BUT_RIGHT },
	{ key_track_next, BUT_RIGHT | BUT_MID },
	{ key_quit, BUT_RIGHT | BUT_MID | BUT_LEFT }
};

#define SIZE_BKEYS (sizeof(bkeys) / sizeof(bkeys[0]))

#define CONSOLE_NAME "Mouse"

MouseConsole::MouseConsole(char *mousename) {
	nameofdevice = (char *)malloc(sizeof(CONSOLE_NAME)+3+strlen(mousename)+1);
	strcat(nameofdevice, CONSOLE_NAME);
	strcat(nameofdevice, ", ");
	strcat(nameofdevice, mousename);
	if (0 > (fd = open(mousename, O_RDONLY))) {
		cout << "mouse " << fd << " open" << endl;
		sleep(1);
	}
}

MouseConsole::~MouseConsole(void) {
	close(fd);
}

tape_key MouseConsole::getcommand(fd_set *read_set, tape_key lastcmd) {
	int i;
	tape_key key = lastcmd;

	if (FD_ISSET(fd, read_set)) {
		read(fd, &mbuf, sizeof(mbuf));
		i = 0;
		while (i < SIZE_BKEYS && key == lastcmd) {
			if (bkeys[i].but == mbuf.but & 0x0F)
				key = bkeys[i].key;
			i++;
		}
		if (key == key_last)
			key = key_none;
		memcpy(&mbuf_old, &mbuf, sizeof(mbuf_old));
	}

	return key;
}

int MouseConsole::fd_set_read(fd_set *read_set) {
	FD_SET(fd, read_set);

	return fd;
}

int MouseConsole::help(int outdev) {

	dprintf(outdev, "Help mouse.\n");

	return 0;
}
