/* speakrec.h
 * by Hans Schou
 */

#ifndef _SPEAKREC_H
#define _SPEAKREC_H

#define NUM_SEGMENTS 7

typedef enum {
	but_none,
	but_stop,
	but_play,
	but_record,
	but_track_prev,
	but_track_next,
	but_rewind,
	but_forward,
	but_edit,
	but_menu
} button_name;

typedef enum {
	key_none,
	key_stop,
	key_play,
	key_record,
	key_track_next,
	key_track_prev,
	key_rewind_inc,
	key_rewind_dec,
	key_forward_inc,
	key_forward_dec,
	key_edit,
	key_menu,
	key_quit
} tape_key;

typedef enum {
	tape_noaction,
	tape_stop,
	tape_play,
	tape_record,
	tape_track_prev,
	tape_track_next,
	tape_rewind_1,
	tape_rewind_2,
	tape_rewind_3,
	tape_rewind_4,
	tape_rewind_6,
	tape_rewind_12,
	tape_forward_1,
	tape_forward_2,
	tape_forward_3,
	tape_forward_4,
	tape_forward_6,
	tape_forward_12,
	tape_edit,
	tape_menu,
	tape_quit
} tape_action;

#if 0
struct sspeakrecord {
	int numoftracks;
	int tracknum; /* Current track number. Range: 0 to numoftracks. */
	int samplespeed; /* Sample rate, typical 44100. */
	int depth; /* Sample bytes (bits 8 or 16), typical 2. Can be 1. */
	int channels; /* Number of channels, typical 1 (mono). */
	int bytespersecond; /* Typical 44100*1*2 = 88200 */
	/* While playing */
	int playspeed; /* Typical 1. 0 == Stop. -1 == Play reverse. */
	int maxplayspeed; /* Maximum play speed. Typical 12. */
	unsigned char *filebuf;
	unsigned char *playbuf;
	int filebufsize; /* 1/10 second * maxplayspeed == 12*8820. */
	int playbufsize; /* Typical 0.1 second == 8820 bytes. */
	int filepos; /* Current position in file (bytes). */
	FILE *filefd;
	FILE *audiofd;
};
#endif

#if 0
typedef struct sdevset {
	struct sdevset *next;
	struct sdevset *prev;
	char *label;
	char *filename;
	int fd;
	int (*openfunc)(struct sdevset *self, struct sspeakrecord *curr);
	int (*closefunc)(struct sspeakrecord *curr);
	//enum tape_key (*readfunc)(struct sspeakrecord *curr);
	int (*writefunc)(struct sspeakrecord *curr);
	unsigned char *localdata;
} *pdevset;
#endif

/*
 * Classes
 * http://www.4p8.com/eric.brasseur/cppcen.html
 */

#endif
