#ifndef _TAPEBOXCONSOLE_H
#define _TAPEBOXCONSOLE_H

#include <iostream>
#include <sys/time.h>
#include <unistd.h>
#include <termios.h>
#include "speakrec.h"
#include "cconsole.h"

using namespace std;

class TapeboxConsole: public CConsole {
public:
	struct termios term_orig;

	TapeboxConsole(char *tapeboxname);
	~TapeboxConsole();
	int flush(void);
	tape_key getcommand(fd_set *read_set, tape_key lastcmd);
	int fd_set_read(fd_set *read_set);
	int fd_set_write(fd_set *write_set);
	int redraw(void);
	int setvolume(int newvol, int peakvol);
	int showsegment(int num, unsigned char value);
	int setbuttonon(button_name name);
	int help(int outdev);
	int senddata(unsigned char addr, unsigned char value);
	int reconnect(void);

private:
	int lastbinvol;
	tape_key prev_key;
	char *devicename;
	unsigned char ondisplay[16];
};

#endif
