#ifndef _TERMCONSOLE_H
#define _TERMCONSOLE_H

#include <iostream>
#include <sys/time.h>
#include <unistd.h>
#include <termios.h>
#include "speakrec.h"
#include "cconsole.h"

class TermConsole: public CConsole {
public:
	long lastsecond;

	TermConsole ();
	~TermConsole ();
	int flush(void);
	tape_key getcommand(fd_set *read_set, tape_key lastcmd);
	int fd_set_read(fd_set *read_set);
	int fd_set_write(fd_set *write_set);
	int redraw(void);
	int setvolume(int newvol, int peakvol);
	int showsegment(int num, unsigned char value);
	int setbuttonon(button_name name);
	int help(int outdev);

private:
	char lastcolor;
	struct termios save_termios;
	int putcha(char c);
	unsigned char bignum(unsigned char n);
};

#endif
